(******************************************************************************
 * ACBiOption                                                                 *
 ******************************************************************************)
unit ACBiOption;

(******************************************************************************
 * interface                                                                  *
 ******************************************************************************)
interface

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

(******************************************************************************
 * Type                                                                       *
 ******************************************************************************)
type
  TACBiOption = class(TCustomPanel)
  private
    { Private declarations }
    F_Caption_A,
    F_Caption_B : String;
    F_First_Checked : Boolean;
    F_Line_Colore : TColor;
  protected
    { Protected declarations }
    Procedure Set_Caption_A(Txt:String);
    Procedure Set_Caption_B(Txt:String);
    Procedure Set_First_Checked(Fl:Boolean);
    Procedure Set_Line_Colore(Cl:TColor);
    procedure WMMButtonDown(var Message: TWMMButtonDown); message WM_LBUTTONDOWN;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); Override;
    destructor Destroy; Override;
    Procedure Paint; Override;

  published
    { Published declarations }
    Property Font;
    Property Caption_A : String Read F_Caption_A Write Set_Caption_A;
    Property Caption_B : String Read F_Caption_B Write Set_Caption_B;
    Property First_Checked : Boolean Read F_First_Checked Write Set_First_Checked;
    Property Line_Color : TColor Read F_Line_Colore Write Set_Line_Colore;
    Property Cursor;
 //   Property Caption;

  end;

(******************************************************************************
 * Implementation                                                             *
 ******************************************************************************)
implementation

(******************************************************************************
 * constructor                                                                *
 ******************************************************************************)
constructor TACBiOption.Create(AOwner: TComponent);
begin
 Inherited;
 Text          := '';
 Ctl3D         := False;
 BevelOuter    := bvNone;
 ParentColor   := True;
 Caption_A     := 'Caption_A';
 Caption_B     := 'Caption_B';
 Line_Color    := ClRed;
 First_Checked := True;

// Color := clred;
end;


(******************************************************************************
 * Set_Caption_A                                                              *
 ******************************************************************************)
Procedure TACBiOption.Set_Caption_A(Txt:String);
begin
  F_Caption_A := Txt;
  Invalidate;
end;

(******************************************************************************
 * Set_Caption_B                                                             *
 ******************************************************************************)
Procedure TACBiOption.Set_Caption_B(Txt:String);
begin
 F_Caption_B := Txt;
 Invalidate;
end;

(******************************************************************************
 * Paint                                                                      *
 ******************************************************************************)
Procedure TACBiOption.Paint;
Const ALTEZZA_PER_LINEA = 2;
//Var PosX,PosY,Larghezza : Integer;
Var PosX,PosY : Integer;
begin
  Caption       := '';
  Inherited;
  Canvas.Font.Assign(Font);

//  Larghezza := Canvas.TextWidth(Caption_A);
//  if (Larghezza < Canvas.TextWidth(Caption_B)) then Larghezza := Canvas.TextWidth(Caption_B);
(********** Prima Caption **********)
  With Canvas Do
  begin
    PosY := (Height - (TextHeight(Caption_A)+TextHeight(Caption_B)+ALTEZZA_PER_LINEA)) div 2;
    if(PosY<0) then PosY := 2;
    PosX := (Width-TextWidth(Caption_A)) div 2;
    TextOut(PosX,PosY,Caption_A);
    if(First_Checked) then
    begin
      Pen.Color := Line_Color;
      Pen.Width := 2;
      MoveTo(PosX,2+PosY+TextHeight(Caption_A) div 2);
      LineTo(PosX+TextWidth(Caption_A),2+PosY+TextHeight(Caption_A) div 2);
    end;
(********** Linea **********)
    PosY := PosY + Canvas.TextHeight(Caption_A) + ALTEZZA_PER_LINEA;
    Pen.Width := 1;
    Pen.Color := Font.Color;
    MoveTo(0,PosY);
    LineTo(Width,PosY);
(********** Seconda Caption **********)
    PosX := (Width-TextWidth(Caption_B)) div 2;
    PosY := PosY + ALTEZZA_PER_LINEA;
    Canvas.TextOut(PosX,PosY,Caption_B);
    if(Not First_Checked) then
    begin
      Pen.Color := Line_Color;
      Pen.Width := 2;
      MoveTo(PosX,2+PosY+TextHeight(Caption_B) div 2);
      LineTo(PosX+TextWidth(Caption_B),2+PosY+TextHeight(Caption_B) div 2);
    end;
  End;

end;

(******************************************************************************
 * destructor                                                                 *
 ******************************************************************************)
destructor TACBiOption.Destroy;
begin
  Inherited;
end;

(******************************************************************************
 * Set_First_Checked                                                          *
 ******************************************************************************)
Procedure TACBiOption.Set_First_Checked(Fl:Boolean);
begin
 F_First_Checked := Fl;
 Invalidate;
end;
(******************************************************************************
 * Set_Line_Colore                                                            *
 ******************************************************************************)
Procedure TACBiOption.Set_Line_Colore(Cl:TColor);
Begin
 F_Line_Colore := Cl;
 Invalidate;
End;

procedure TACBiOption.WMMButtonDown(var Message: TWMMButtonDown);
Begin
  Inherited;
  First_Checked := Not First_Checked;
End;
end.
