(******************************************************************************
 * ACDialogEngine                                                             *
 ******************************************************************************)
 unit ACDialogEngine;

(******************************************************************************
 * interface                                                                  *
 ******************************************************************************)
interface

(******************************************************************************
 * uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

(******************************************************************************
 * type                                                                       *
 ******************************************************************************)
type
  ACDEPosition = (ACDETopLeft,
                  ACDETopRight,
                  ACDETopCenter,
                  ACDEBottomLeft,
                  ACDEBottomRight,
                  ACDEBottomCenter,
                  ACDELeftTop,
                  ACDERightTop,
                  ACDELeftBottom,
                  ACDERightBottom);
  TACDialogEngine = class(TCustomPanel)//TComponent)
  private
    { Private declarations }
    F_Style : ACDEPosition;
  protected
    { Protected declarations }
    procedure Set_Style(V:ACDEPosition);
    procedure paint;override;
    procedure DisegnaBordo(x1,y1,x2,y2 : Integer;
                                       linea1,linea2,linea3: array of TPoint);

  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Disegna;
    property OnExit;
  published
    { Published declarations }
    property Style : ACDEPosition Read F_Style Write Set_Style;
  end;

(******************************************************************************
 * implementation                                                             *
 ******************************************************************************)
implementation


(******************************************************************************
 * constructor                                                                *
 ******************************************************************************)
constructor TACDialogEngine.Create(AOwner: TComponent);
begin
 Inherited;
 if (Parent <> nil) and not(Parent is TForm) then
   raise EInvalidOperation.Create('A TACDialogEngine can only placed in a Form');

 Align := alClient;
 Color := clInfoBk;

end;

(******************************************************************************
 * Destroy                                                                    *
 ******************************************************************************)
destructor TACDialogEngine.Destroy;
begin
  inherited Destroy;
end;

(******************************************************************************
 * DisegnaBordo                                                               *
 ******************************************************************************)
procedure TACDialogEngine.DisegnaBordo(x1,y1,x2,y2 : Integer;
                                       linea1,linea2,linea3: array of TPoint);
begin

  with canvas do
  begin
//    Brush.Colore := Color;
//    Rectangle(0,0,x2,y2);
    Pen.Color := clBlack;
    Pen.Width := 1;
    RoundRect(x1,y1,x2,y2,20,20);
    Pen.Color := color;
//    Moveto(xa,ya);
//    Lineto(xb,yb);
    Polygon(Linea1);
    Pen.Color := clBlack;
    Polygon(Linea2);
    Polygon(Linea3);
//    Moveto(xb,yb);
//    LineTo(xc,yc);
//    Moveto(xc,yc);
//    LineTo(xa,ya);
  End;

end;
(******************************************************************************
 * Disegna                                                                    *
 ******************************************************************************)
procedure TACDialogEngine.Disegna;
type
    PPoints = ^TPoints;
    TPoints = array[0..0] of TPoint;
var //hr : TRect;
    hr,hr1,hr2 : HRgn;
    punti   : Array [0..2] of tpoint;
    Frm     : TForm;
begin
 Frm := TForm(Owner);
 Frm.BorderStyle := bsNone;
 Frm.FormStyle   := fsStayOnTop;
 Case Style of
//********** ACDETopLeft **********
 ACDETopLeft:
  begin
   Hr := CreateRectRgn(0,0,0,0);
   hr1 := CreateRoundRectRgn(0, 20, Frm.width, frm.Height, 20, 20);
   Punti[0].x:= 20;
   Punti[0].y:= 20;
   Punti[1].x:= 20;
   Punti[1].y:= 00;
   Punti[2].x:= 30;
   Punti[2].y:= 20;
   hr2:=CreatePolygonRgn(PPoints(@Punti)^, 3,ALTERNATE);
   CombineRgn(hr,hr1,hr2,RGN_OR);
   SetWindowRgn(frm.handle,hr,true);
   DisegnaBordo(0, 20, frm.width-1, frm.height-1,  // Rettangolo
                [Point(20,20),Point(30-1,20)],
                [Point(30-1,20),Point(20,1)],
                [Point(20,1),Point(20,20)]);
  End;
//********** ACDETopRight **********
  ACDETopRight:
  begin
   Hr := CreateRectRgn(0,0,0,0);
   hr1 := CreateRoundRectRgn(0, 20, frm.width, frm.Height, 20, 20);
   Punti[0].x:= frm.width-20;
   Punti[0].y:= 20;
   Punti[1].x:= frm.width-20;
   Punti[1].y:= 00;
   Punti[2].x:= frm.width-30;
   Punti[2].y:= 20;
   hr2:=CreatePolygonRgn(PPoints(@Punti)^, 3,ALTERNATE);
   CombineRgn(hr,hr1,hr2,RGN_OR);
   SetWindowRgn(frm.handle,hr,true);
   DisegnaBordo(0, 20, frm.width-1, frm.height-1,  // Rettangolo
                [Point(frm.width-30,20),  Point(frm.width-20-1,20)],
                [Point(frm.width-30,20),  Point(frm.width-20,1)],
                [Point(frm.width-20-1,20),Point(frm.width-20-1,1)]);
  End;
//********** ACDETopCenter **********
  ACDETopCenter:
  begin
   Hr := CreateRectRgn(0,0,0,0);
   hr1 := CreateRoundRectRgn(0, 20, frm.width, frm.Height, 20, 20);
   Punti[0].x:= (frm.width div 2)-20;
   Punti[0].y:= 20;
   Punti[1].x:= (frm.width div 2)-20;
   Punti[1].y:= 00;
   Punti[2].x:= (frm.width div 2)-30;
   Punti[2].y:= 20;
   hr2:=CreatePolygonRgn(PPoints(@Punti)^, 3,ALTERNATE);
   CombineRgn(hr,hr1,hr2,RGN_OR);
   SetWindowRgn(frm.handle,hr,true);
   DisegnaBordo(0, 20, frm.width-1, frm.height-1,  // Rettangolo
                [Point((frm.width div 2)-30, 20), Point((frm.width div 2)-20-1, 20)],
                [Point((frm.width div 2)-20, 1), Point((frm.width div 2)-30, 20)],
                [Point((frm.width div 2)-20-1, 20), Point((frm.width div 2)-20-1, 0)]);

  End;

//********** ACDEBottomLeft **********
  ACDEBottomLeft:
  begin
   Hr := CreateRectRgn(0,0,0,0);
   hr1 := CreateRoundRectRgn(0, 0, frm.width, frm.Height-20, 20, 20);
   Punti[0].x:= 20;
   Punti[0].y:= frm.Height-20-1;
   Punti[1].x:= 20;
   Punti[1].y:= frm.Height-1;
   Punti[2].x:= 30;
   Punti[2].y:= frm.Height-20-1;
   hr2:=CreatePolygonRgn(PPoints(@Punti)^, 3,ALTERNATE);
   CombineRgn(hr,hr1,hr2,RGN_OR);
   SetWindowRgn(frm.handle,hr,true);
   DisegnaBordo(0, 0, frm.width-1, frm.height-20-1,  // Rettangolo
                [Point(20,frm.height-20-1-1),Point(30-1,frm.height-20-1-1)],
                [Point(30-1,frm.height-20-1),Point(20,frm.height-1-1)],
                [Point(20,frm.height-20-1),Point(20,frm.height-1-1)]);
  End;
//********** ACDEBottomRight **********
  ACDEBottomRight:
  begin
   Hr := CreateRectRgn(0,0,0,0);
   hr1 := CreateRoundRectRgn(0, 0, frm.width, frm.Height-20, 20, 20);
   Punti[0].x:= frm.width-20;
   Punti[0].y:= frm.Height-20-1;
   Punti[1].x:= frm.width-20;
   Punti[1].y:= frm.Height-00-1;
   Punti[2].x:= frm.width-30;
   Punti[2].y:= frm.Height-20-1;
   hr2:=CreatePolygonRgn(PPoints(@Punti)^, 3,ALTERNATE);
   CombineRgn(hr,hr1,hr2,RGN_OR);
   SetWindowRgn(frm.handle,hr,true);
   DisegnaBordo(0, 0, frm.width-1, frm.height-20-1,  // Rettangolo
                [Point(frm.Width-20-1,frm.height-20-1-1), Point(frm.Width-30,frm.height-20-1-1)],
                [Point(frm.Width-30,frm.height-20-1), Point(frm.Width-20,frm.height-1-1)],
                [Point(frm.Width-20-1,frm.height-20-1), Point(frm.Width-20-1,frm.height-1-1)]);


  End;
//********** ACDEBottomCenter **********
  ACDEBottomCenter:
  begin
   Hr := CreateRectRgn(0,0,0,0);
   hr1 := CreateRoundRectRgn(0, 0, frm.width, frm.Height-20, 20, 20);
   Punti[0].x:= (frm.Width div 2)-20;
   Punti[0].y:= frm.Height-20-1;
   Punti[1].x:= (frm.Width div 2)-20;
   Punti[1].y:= frm.Height-00-1;
   Punti[2].x:= (frm.Width div 2)-30;
   Punti[2].y:= frm.Height-20-1;
   hr2:=CreatePolygonRgn(PPoints(@Punti)^, 3,ALTERNATE);
   CombineRgn(hr,hr1,hr2,RGN_OR);
   SetWindowRgn(frm.handle,hr,true);
   DisegnaBordo(0, 0, frm.width-1, frm.height-20-1,  // Rettangolo
                [Point((frm.Width div 2)-20-1,frm.height-20-1-1), Point((frm.Width div 2)-30,frm.height-20-1-1)],
                [Point((frm.Width div 2)-30,frm.height-20-1), Point((frm.Width div 2)-20,frm.height-1-1)],
                [Point((frm.Width div 2)-20-1,frm.height-20-1), Point((frm.Width div 2)-20-1,frm.height-1-1)]);

  End;

//********** ACDELeftTop **********
  ACDELeftTop:
  begin
   Hr := CreateRectRgn(0,0,0,0);
   hr1 := CreateRoundRectRgn(20, 0, frm.width, frm.Height, 20, 20);
   Punti[0].x:= 20;
   Punti[0].y:= 20;
   Punti[1].x:= 00;
   Punti[1].y:= 20;
   Punti[2].x:= 20;
   Punti[2].y:= 30;
   hr2:=CreatePolygonRgn(PPoints(@Punti)^, 3,ALTERNATE);
   CombineRgn(hr,hr1,hr2,RGN_OR);
   SetWindowRgn(frm.handle,hr,true);
   DisegnaBordo(20, 0, frm.width-1, frm.height-1,  // Rettangolo
                [Point(20,20), Point(20,30)],
                [Point(20,30), Point(00,20)],
                [Point(00,20), Point(20,20)]);
//   DisegnaBordo(20, 0, frm.width-1, frm.height-1, // Rettangolo
//                20, 20,     // Punto 1
//                20, 30,     // Punto 2
//                00, 20);    // Punto 3

  End;
//********** ACDELeftBottom **********
  ACDELeftBottom:
  begin
   Hr := CreateRectRgn(0,0,0,0);
   hr1 := CreateRoundRectRgn(20, 0, frm.width, frm.Height, 20, 20);
   Punti[0].x:= 20;
   Punti[0].y:= frm.height-20;
   Punti[1].x:= 00;
   Punti[1].y:= frm.height-20;
   Punti[2].x:= 20;
   Punti[2].y:= frm.height-30;
   hr2:=CreatePolygonRgn(PPoints(@Punti)^, 3,ALTERNATE);
   CombineRgn(hr,hr1,hr2,RGN_OR);
   SetWindowRgn(frm.handle,hr,true);
   DisegnaBordo(20, 0, frm.width-1, frm.height-1,  // Rettangolo
                [Point(20,frm.Height-20-1), Point(20,frm.Height-30)],
                [Point(20,frm.Height-30), Point(01,frm.Height-20)],
                [Point(00,frm.Height-20-1), Point(20,frm.Height-20-1)]);
  End;

//********** ACDERightTop **********
  ACDERightTop:
  begin
   Hr := CreateRectRgn(0,0,0,0);
   hr1 := CreateRoundRectRgn(0, 0, frm.width-20, frm.Height, 20, 20);
   Punti[0].x:= frm.width-20-1;
   Punti[0].y:= 20;
   Punti[1].x:= frm.width-00-1;
   Punti[1].y:= 20;
   Punti[2].x:= frm.width-20-1;
   Punti[2].y:= 30;
   hr2:=CreatePolygonRgn(PPoints(@Punti)^, 3,ALTERNATE);
   CombineRgn(hr,hr1,hr2,RGN_OR);
   SetWindowRgn(frm.handle,hr,true);
   DisegnaBordo(0, 0, frm.width-20-1, frm.height-1, // Rettangolo
                [Point(frm.Width-20-1-1,20), Point(frm.Width-20-1-1,30)],
                [Point(frm.Width-20-1-1,30), Point(frm.Width-1-1,20)],
                [Point(frm.Width-1,20), Point(frm.Width-20-1,20)]);


  End;
//********** ACDERightBottom **********
  ACDERightBottom:
  begin
   Hr := CreateRectRgn(0,0,0,0);
   hr1 := CreateRoundRectRgn(0, 0, frm.width-20, frm.Height, 20, 20);
   Punti[0].x:= frm.width-20-1;
   Punti[0].y:= frm.height-20-1;
   Punti[1].x:= frm.width-00-1;
   Punti[1].y:= frm.height-20-1;
   Punti[2].x:= frm.width-20-1;
   Punti[2].y:= frm.height-30-1;
   hr2:=CreatePolygonRgn(PPoints(@Punti)^, 3,ALTERNATE);
   CombineRgn(hr,hr1,hr2,RGN_OR);
   SetWindowRgn(frm.handle,hr,true);
   DisegnaBordo(0, 0, frm.width-20-1, frm.height-1, // Rettangolo
                [Point(frm.Width-20-1-1,frm.Height-20-1-1), Point(frm.Width-20-1-1,frm.Height-30)],
                [Point(frm.Width-20-1-1,frm.Height-30-1), Point(frm.Width-1,frm.Height-20)],
                [Point(frm.Width-20-1-1,frm.Height-20-1-1), Point(frm.Width-1,frm.Height-20-1-1)]);

 //  DisegnaBordo(0, 0, frm.width-20-1, frm.height-1, // Rettangolo
 //               frm.Width-20-1, frm.Height-20-1,     // Punto 1
 //               frm.Width-20-1, frm.Height-30-1,     // Punto 2
 //               frm.Width-00-1, frm.Height-20-1);    // Punto 3
//   DisegnaBordo(20, 0, frm.width-1, frm.height-1,  // Rettangolo
//                [Point(20,frm.Height-20-1), Point(20,frm.Height-30)],
//                [Point(20,frm.Height-30), Point(01,frm.Height-20)],
//                [Point(00,frm.Height-20-1), Point(20,frm.Height-20-1)]);

  End;

 end;

end;

(******************************************************************************
 * Set_Style                                                                  *
 ******************************************************************************)
procedure TACDialogEngine.Set_Style(V:ACDEPosition);
begin
  F_Style := v;
  Invalidate;
  Disegna;
end;

(******************************************************************************
 * Paint                                                                      *
 ******************************************************************************)
procedure TACDialogEngine.paint;
begin
  inherited;
  disegna;
End;
end.
