(******************************************************************************
 * ACFileIcon                                                                 *
 ******************************************************************************)
 unit ACFileIcon;

(******************************************************************************
 * Interface                                                                  *
 ******************************************************************************)
 interface

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
 uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

(******************************************************************************
 * Type                                                                       *
 ******************************************************************************)
 type
  TACFileIcon = class(TComponent)
  private
    { Private declarations }
    F_FileName : String;
    F_Icon         : TIcon;
  protected
    { Protected declarations }
    procedure Set_FileName(Nome:String);
    Procedure Set_Icon(Ico:TIcon);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published declarations }
    property FileName : String Read F_FileName Write Set_FileName;
    Property Icon     : TIcon Read F_Icon Write Set_Icon;
  end;

(******************************************************************************
 * Implementation                                                             *
 ******************************************************************************)
implementation

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
 uses Shellapi;


(******************************************************************************
 * Set_FileName                                                               *
 ******************************************************************************)
procedure TACFileIcon.Set_FileName(Nome:String);
Var    SFI  : TShFileInfo;
begin
  f_filename := Nome;
  SHGetFileInfo(PChar(FileName), 0, SFI, SizeOf(SFI), SHGFI_ICON);
  If SFI.hIcon <> 0 Then F_Icon.Handle := SFI.hIcon
  Else F_Icon.Handle := 0;

end;

(******************************************************************************
 * Set_Icon                                                                   *
 ******************************************************************************)
Procedure TACFileIcon.Set_Icon(Ico:TIcon);
begin
end;

(******************************************************************************
 * Constructor                                                                *
 ******************************************************************************)
constructor TACFileIcon.Create(AOwner: TComponent);
Begin
 inherited;
 F_Icon := TIcon.Create;
End;

(******************************************************************************
 * Destructor                                                                 *
 ******************************************************************************)
destructor TACFileIcon.Destroy;
Begin
 F_Icon.Free;
 Inherited;
End;


end.
