(******************************************************************************
 * ACMoveBox                                                                  *
 ******************************************************************************)
unit ACMoveBox;

(******************************************************************************
 * interface                                                                  *
 ******************************************************************************)
interface

(******************************************************************************
 * uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, AcProcDeclare, stdctrls;

(******************************************************************************
 * type                                                                       *
 ******************************************************************************)
type
  TACMoveBox = class(TcustomLabel) //TCustomControl
  private
    { Private declarations }
    F_Width,
    F_Left,
    F_Top,
    F_Height : Integer;
    premuto : Boolean;
    old_x,old_y : Integer;
    Iniziato : Boolean;
    F_Box_Moved : TAC_Proc_Box_Moved;
  protected
    { Protected declarations }
    Maniglie : Array[1..8] of TShape;
    procedure disegna;
    procedure down_0(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Up_0(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
    procedure move_0(Sender: TObject; Shift: TShiftState; X,Y: Integer);
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
//    procedure WMLButtonDown(var Message: TWMLButtonDown); message WM_LButtonDown;
    procedure Paint;override;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published declarations }
    property OnBoxMoved : TAC_Proc_Box_Moved Read F_Box_Moved Write F_Box_Moved;
    property Visible;
    property PopupMenu;
  end;

(******************************************************************************
 * implementation                                                             *
 ******************************************************************************)
implementation

//uses  unit1;

(******************************************************************************
 * Costanti                                                                   *
 ******************************************************************************)
const Margine_Maniglia = 2;
      Dimensione_Maniglia = Margine_Maniglia * 2;

(******************************************************************************
 * Constructor                                                                *
 ******************************************************************************)
constructor TACMoveBox.Create(AOwner: TComponent);
begin
  Iniziato := False;
  inherited Create(AOwner);
//  brush.style:=bsClear;
//  pen.style:=psDash;
  color := clred;
  premuto:=False;
  OnBoxMoved:=Nil;
  onmousedown := down_0;
  onmouseup := up_0;
  onmousemove := move_0;
  transparent:=True;

end;

(******************************************************************************
 * Disegna                                                                    *
 ******************************************************************************)
procedure TACMoveBox.disegna;
Var c1 : Integer;
begin
  if(not iniziato) then
  begin
    for c1 := 1 to 8 do
    begin

      maniglie[c1]:=TShape.Create(Self);
      maniglie[c1].parent:=Parent;
      maniglie[c1].brush.color := clBlack;
//      maniglie[c1].parent:=Parent;
      maniglie[c1].BringToFront;
      maniglie[c1].Width := Dimensione_Maniglia+200;
      maniglie[c1].Height := Dimensione_Maniglia+220;

    end;

    Iniziato:=True;
  end;

  maniglie[1].Left := 10;
  maniglie[1].top := 10;
  maniglie[1].BringToFront;
  maniglie[1].cursor := crSizeNWSE;

  maniglie[2].Left := (Width-Dimensione_Maniglia)div 2;
  maniglie[2].top := 0;
  maniglie[2].BringToFront;
  maniglie[2].cursor := crSizeNS;

  maniglie[3].Left := Width-Dimensione_Maniglia;
  maniglie[3].top := 0;
  maniglie[3].BringToFront;
  maniglie[3].cursor := crSizeNESW;

  maniglie[4].Left := 0;
  maniglie[4].top := (Height-Dimensione_Maniglia) div 2 ;
  maniglie[4].BringToFront;
  maniglie[4].cursor := crSizeWE;

  maniglie[5].Left := Width-Dimensione_Maniglia;
  maniglie[5].top := (Height-Dimensione_Maniglia) div 2;
  maniglie[5].BringToFront;
  maniglie[5].cursor := crSizeWE;

  maniglie[6].Left := 0;
  maniglie[6].top := Height-Dimensione_Maniglia;
  maniglie[6].BringToFront;
  maniglie[6].cursor := crSizeNESW;

  maniglie[7].Left := (Width-Dimensione_Maniglia)div 2;
  maniglie[7].top := Height-Dimensione_Maniglia;
  maniglie[7].BringToFront;
  maniglie[7].cursor := crSizeNS;

  maniglie[8].Left := Width-Dimensione_Maniglia;
  maniglie[8].top := Height-Dimensione_Maniglia;
  maniglie[8].BringToFront;
  maniglie[8].cursor := crSizeNWSE;



end;

(******************************************************************************
 * Destructor                                                                 *
 ******************************************************************************)
destructor TACMoveBox.Destroy;
Var c1 : Integer;
begin
  if (Iniziato) then
  begin
    for c1 := 1 to 8 do
    begin
      maniglie[c1].Free;
    end;
  end;
  inherited;
end;


(******************************************************************************
 * Down_o                                                                     *
 ******************************************************************************)
procedure TACMoveBox.down_0(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
//procedure TACMoveBox.WMLButtonDown(var Message: TWMLButtonDown);
begin
  inherited;
  premuto:=True;
//  old_x := Message.xpos;
//  old_Y := Message.ypos;
  old_x := x;
  old_Y := y;

end;


(******************************************************************************
 * up_o                                                                       *
 ******************************************************************************)
procedure TACMoveBox.Up_0(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  premuto:=False;
  if(Assigned(OnBoxMoved)) then onBoxMoved(Self);
end;

(******************************************************************************
 * Move_o                                                                     *
 ******************************************************************************)
procedure TACMoveBox.move_0(Sender: TObject; Shift: TShiftState; X,Y: Integer);
begin
  inherited;

  if(Premuto) then
  begin
    left := left + x - old_x;
    top := top + y - old_y;
//    old_x:=x;
  end;
end;

(******************************************************************************
 * Wm_Size                                                                    *
 ******************************************************************************)
procedure TACMoveBox.WMSize(var Message: TWMSize);
begin

  inherited;
//  exit;
  disegna;
//  invalidate;
end;


procedure TACMoveBox.Paint;
begin
  inherited;
  canvas.pen.color:=clBlack;
  canvas.pen.style:=psDash;
  canvas.rectangle(0,0,width-1,height-1);
end;

end.
