(******************************************************************************
 * EdFName                                                                    *
 ******************************************************************************)
unit AcEdFName;

(******************************************************************************
 * interface                                                                  *
 ******************************************************************************)
interface

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
Uses DsgnIntf, SysUtils, Controls, Classes, Forms;

(******************************************************************************
 * TFileNameProperty                                                          *
 ******************************************************************************)
type TFileNameProperty = Class(TStringProperty)
 public
   procedure Edit; override;
   function GetAttributes : TPropertyAttributes; override;
//   function GetValue: string; override;
 end;

(******************************************************************************
 * implementation                                                             *
 ******************************************************************************)
implementation

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
Uses Dialogs, AcLibForm;

(******************************************************************************
 * Edit                                                                       *
 ******************************************************************************)
procedure TFileNameProperty.Edit;
Var //Dlg : TOpenDialog;
   FormComp : TACLibFormComp;
begin
  try
    //dlg := TOpenDialog.Create(Application);
    FormComp := TACLibFormComp.Create(Application);
    FormComp.OpenDialog1.Filter := 'Log|*.Log';
    FormComp.OpenDialog1.Options := [ofPathMustExist,ofFileMustExist];
    if (FormComp.OpenDialog1.Execute) then SetValue(FormComp.OpenDialog1.FileName);
  finally
    FormComp.Free;
  end;
end;

(******************************************************************************
 * GetAttributes                                                              *
 ******************************************************************************)
function TFileNameProperty.GetAttributes : TPropertyAttributes;
begin
  Result:=inherited GetAttributes+[paDialog, paMultiSelect];
end;


end.
